#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <ctype.h>

/* nahodna cisla */
void nahodneCisloUkazatel(int *cislo);
int nahodneCislo(int max);

/* prace s polem */
void naplnPole(int a[], int velikost);
void vypisPole(int a[], int velikost);
void zamichejPole(int a[], int velikost);
void prehazejPole(int a[], int velikost);

/* retezce */
int jeObrazem(char str[], char str2[]);
int stejnaPismena(char str[], char str2[]);
void cetnostZnaku(char str[], int cetnost[]);

int main(int argc, char** argv) {
#define VELIKOST_POLE 10
    int pole[VELIKOST_POLE];
    int i;
    int *pole2;

    srand((unsigned) time(NULL));

    /*nahodneCislo(&i);*/
    i = nahodneCislo(100);
    printf("Hodnota promenne i: %d\n", i);


    vypisPole(pole, VELIKOST_POLE);
    naplnPole(pole, VELIKOST_POLE);
    vypisPole(pole, VELIKOST_POLE);
    zamichejPole(pole, VELIKOST_POLE);
    vypisPole(pole, VELIKOST_POLE);
    prehazejPole(pole, VELIKOST_POLE);
    vypisPole(pole, VELIKOST_POLE);


    printf("je obrazem %d \n", jeObrazem("ahoj", "joha"));
    printf("stejne znaky %d \n", stejnaPismena("Ahoj Pepo, jak se vede?", "Aohj Ppeo, jak svd?"));


    pole2 = pole;
    /*pole2 = &pole[0];*/
    printf("%d \n", (pole)[3]);
    printf("%d \n", (pole+1)[3]);
    printf("%d \n", pole2[3]);
    printf("%d \n", *pole2);
    printf("%d \n", *(pole2 + 3));


    /*
    int *up, **uup, pole3[] = {5, -6, 0, 8, -9, 3, 1, -4};

    up = pole3;
    uup = &up;

    printf("pole[1] = %d \n", pole3[1]);
    printf("pole[1] + 4 = %d \n", pole3[1] + 4);
    printf("(pole + 1)[2] = %d \n", (pole3 + 1)[2]);

    printf("*up = %d \n", *up);
    printf("*up + 4 = %d \n", *up + 4);
    printf("*(up + 1) = %d \n", *(up + 1));

    printf("**uup = %2d \n", **uup);
    printf("*(*uup + 2) = %2d \n", *(*uup + 2));
    printf("**uup + 4) = %2d \n", **uup + 4);
    */
    
    return (EXIT_SUCCESS);
}

/* retezce */
void cetnostZnaku(char str[], int cetnost[]) {
    int i;
    for (i = 0; i < 256; i++) {
        cetnost[i] = 0;
    }
    for (i = 0; i < strlen(str); i++) {
        cetnost[(int) str[i]]++;
    }
}

int stejnaPismena(char str[], char str2[]) {
    int cetnost1[256], cetnost2[256];
    int i;
    cetnostZnaku(str, cetnost1);
    cetnostZnaku(str2, cetnost2);
    for (i = 0; i < 256; i++) {
        if ((cetnost1[i] == 0 && cetnost2[i] > 0) || (cetnost1[i] > 0 && cetnost2[i] == 0)) {
            return 0;
        }
    }
    return 1;
}

int jeObrazem(char str[], char str2[]) {
    int i;
    if (strlen(str) != strlen(str2)) {
        return 0;
    }
    for (i = 0; i < strlen(str); i++) {
        if (str[i] != str2[strlen(str2) - 1 - i]) {
            return 0;
        }

    }
    return 1;
}

/* pole */
void prehazejPole(int a[], int velikost) {
    int volna = 0, tmp, i = 0;
    for (i = 0; i < velikost; i++) {
        if (a[i] % 2 == 0) {
            tmp = a[i];
            a[i] = a[volna];
            a[volna] = tmp;
            volna = volna + 1;
        }
    }

}

void naplnPole(int a[], int velikost) {
    int i = 0;
    for (i = 0; i < velikost; i++) {
        a[i] = nahodneCislo(100);
    }
}

void vypisPole(int a[], int velikost) {
    int i = 0;
    for (i = 0; i < velikost; i++) {
        printf("%d ", a[i]);
    }
    printf("\n");
}

void zamichejPole(int a[], int velikost) {
    int i = 0;
    int pozice, temp;
    for (i = 0; i < velikost; i++) {
        pozice = nahodneCislo(velikost);
        temp = a[i];
        a[i] = a[pozice];
        a[pozice] = temp;
    }
}

/* nahodna cisla */
void nahodneCisloUkazatel(int *cislo) {
    srand((unsigned) time(NULL));
    *cislo = rand(); /* pseudonahodne cislo z intervalu 0 az RAND_MAX */
    *cislo = *cislo % 100; /* prevedeno do intervalu 0-99 */
}

int nahodneCislo(int max) {
    int cislo;
    cislo = rand(); /* pseudonahodne cislo z intervalu 0 az RAND_MAX */
    cislo = cislo % max; /* prevedeno do intervalu 0-99 */
    return cislo;
}

